<div class="content-header">
    <div class="container-fluid">
        <h1 class="m-0 text-dark"><strong>{{ 'Users' | translate }}</strong></h1>
    </div>
</div>

<section class="content">
    <div class="card">
        <div class="card-header">
            <div class="float-left">
                <h3 class="card-title">{{ 'Listing of users' | translate }}</h3>
            </div>
            <div class="float-right">
                <button class="btn btn-primary" (click)="createUser()">
                    <i class="fa fa-plus-square"></i> {{ 'Create user' | translate }}
                </button>
            </div>
            <div class="clearfix"></div>
        </div>
        <div class="card-body">
            <div class="form-inline table-filters">
                <div class="form-group">
                    <label class="control-label">{{ 'Name' | translate }}</label>
                    <input type="text" class="form-control" [(ngModel)]="options.filters['name']"/>
                </div>
                <div class="form-group">
                    <label class="control-label">{{ 'E-mail' | translate }}</label>
                    <input type="text" class="form-control" [(ngModel)]="options.filters['email']"/>
                </div>
                <div class="form-group">
                    <button class="btn btn-secondary" (click)="filter()">
                        <i class="fa fa-search"></i> {{ 'Filter' | translate }}
                    </button>
                </div>
            </div>
            <div class="table-responsive" *ngIf="users$ | async; let users">
                <table class="table table-striped">
                    <thead>
                        <tr>
                            <th scope="col" sortable="name" direction="asc" (sort)="onSort($event)">{{ 'Name' | translate }}</th>
                            <th scope="col">{{ 'E-mail' | translate }}</th>
                            <th scope="col" width="150" class="text-center">{{ 'Actions' | translate }}</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr *ngFor="let u of users" [class.text-muted]="!u.isActive">
                            <td>{{ u.fullName }}</td>
                            <td>{{ u.email }}</td>
                            <td>
                                <div class="table-button-container text-center">
                                    <a href="#" class="action-link" (click)="$event.preventDefault(); toggleUserStatus(u)"
                                            [class.text-success]="u.isActive" [class.text-danger]="!u.isActive"
                                            [title]="u.isActive ? 'Disable user' : 'Enable user' | translate">
                                        <i class="fa fa-check"></i>
                                    </a>
                                    <a href="#" class="action-link text-info" (click)="$event.preventDefault(); goEditUser(u)"
                                            [title]="'Edit user' | translate">
                                        <i class="fa fa-pencil-alt"></i>
                                    </a>
                                    <a href="#" class="action-link text-danger" (click)="$event.preventDefault(); deleteUser(u)"
                                            [title]="'Delete user' | translate">
                                        <i class="fa fa-trash"></i>
                                    </a>
                                </div>
                            </td>
                        </tr>
                    </tbody>
                </table>
                <div *ngIf="total$ | async; let total">
                    <div class="d-flex justify-content-between p-2" *ngIf="total / take > 1">
                        <ngb-pagination [collectionSize]="total" [(page)]="page" [pageSize]="take"
                                [maxSize]="5" [rotate]="true" [boundaryLinks]="true"></ngb-pagination>
                        <select class="custom-select" style="width: auto" name="pageSize" [(ngModel)]="take">
                            <option [ngValue]="15">{{ 'pagination' | translate:{count: 15} }}</option>
                            <option [ngValue]="20">{{ 'pagination' | translate:{count: 20} }}</option>
                            <option [ngValue]="30">{{ 'pagination' | translate:{count: 30} }}</option>
                        </select>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <ngx-loading [show]="(loading$ | async) && !modalOpen" [config]="loaderConfig"></ngx-loading>
</section>

<ng-template #userModal>
    <div class="modal-header">
        <h4 class="modal-title" id="modal-basic-title">{{ modal.title | translate }}</h4>
        <button type="button" class="close" aria-label="Close" (click)="modalReference.close()">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body" [style.max-height]="(windowService.innerHeight - 200) + 'px'">
        <app-user-form [user]="selectedUser" [mode]="modal.mode" #userForm></app-user-form>
    </div>
    <div class="modal-footer">
        <button type="button" class="btn btn-primary" (click)="onSubmit(userForm)">{{ 'Save' | translate }}</button>
    </div>
    <ngx-loading [show]="(loading$ | async) && modalOpen" [config]="loaderConfig"></ngx-loading>
</ng-template>